/*
 *  Author     : Arne Vajhj
 *
 *  Programmed : july 1995/july 1996
 *
 *  Purpose    : mini database
 *
 *  Modified   : september 2002
 *               Small HTML corrections.
 *               Replace "+" with " ".
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <jpidef.h>

#include "cgilib.h"
#include "scriptlib.h"

long lib$getjpi();

int check_access();
void replace(char *s,char *s1,char *s2);

main(int argc,char *argv[])
{
   FILE *fpcf,*fptmp;
   int n,la;
   long pid;
   char *cf,db[256],all_a[2001],a[81];
   char tmpfnm[33],cmd[256],tmp[11],*p1,*p2;
   time_t t;
   cgi_init(argc,argv);
   cf=cgi_info("PATH_INFO");
   cf++;
   la=atoi(cgi_info("CONTENT_LENGTH"));
   cgi_read(all_a,la);
   all_a[la]='\0';
   cgi_printf("content-type: text/html\n\n");
   cgi_printf("<HTML>\n");
   cgi_printf("<HEAD>\n");
   cgi_printf("<TITLE>%s</TITLE>\n",cf);
   cgi_printf("</HEAD>\n");
   cgi_printf("<BODY>\n");
   cgi_printf("<H1>%s</H1>\n",cf);
   /* open control-file */
   if(!check_access(cf)) {
      cgi_printf("<P>No access to file: %s</P>\n",cf);
      goto fin;
   }
   fpcf=fopen(cf,"r");
   if(fpcf==NULL) {
       cgi_printf("<P>Can not open file: %s</P>\n",cf);
       goto fin;
   }
   /* read database name and check access */
   fgets(db,sizeof(db),fpcf);
   db[strlen(db)-1]='\0';
   if(!check_access(db)) {
      cgi_printf("<P>No access to file: %s</P>\n",db);
      goto fin;
   }
   /* open temporary file */
   lib$getjpi(&JPI$_PID,0,0,&pid,0,0);
   sprintf(tmpfnm,"%X.ZZZ",pid);
   fptmp=fopen(tmpfnm,"w");
   /* read and write answers */
   n=0;
   for(;;) {
      n++;
      sprintf(tmp,"fld%d=",n);
      p1=strstr(all_a,tmp);
      if(p1==NULL) goto fin2;
      p1=strstr(p1,"=");
      p1++;
      p2=strstr(p1,"&");
      if(p2==NULL) p2=p1+80;
      memset(a,'\0',sizeof(a));
      strncpy(a,p1,p2-p1);
      la = strlen(a);
      net_unescape_string(a,&la);
      a[la] = '\0';
      replace(a,"+"," ");
      fprintf(fptmp,"%s;",a);
   }
fin2:
   t = time(NULL);
   fprintf(fptmp,"%s",ctime(&t));
   fclose(fptmp);
   sprintf(cmd,"APPEND %s %s",tmpfnm,db);
   system(cmd);
   remove(tmpfnm);
   cgi_printf("<P>Record successfully added!</P>\n");
   fclose(fpcf);
fin:
   cgi_printf("</BODY>\n");
   cgi_printf("</HTML>\n");
}
