/*
 *  Author     : Arne Vajhj
 *
 *  Programmed : july 1995/july 1996
 *
 *  Purpose    : mini database
 *
 *  Modified   : august 1996
 *               various small fixes
 *
 *               september 2002
 *               Small HTML corrections.
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include "cgilib.h"

int check_access();

main(int argc,char *argv[])
{
   FILE *fpcf,*fpdb;
   int i,nfld;
   char *p,*p1,*p2,cf[256],db[256],fld[81],lin[4097],title[81];
   cgi_init(argc,argv);
   p=cgi_info("PATH_INFO");
   p++;
   strcpy(cf,p);
   cgi_printf("content-type: text/html\n\n");
   if(strcmp(cgi_info("REQUEST_METHOD"),"HEAD")==0) exit(1);
   /* open control-file */
   if(!check_access(cf)) {
      cgi_printf("<P>No access to file: %s</P>\n",cf);
      goto fin;
   }
   fpcf=fopen(cf,"r");
   if(fpcf==NULL) {
       cgi_printf("<P>Can not open file: %s</P>\n",cf);
       goto fin;
   }
   /* skip lines */
   fgets(db,sizeof(db),fpcf);
   db[strlen(db)-1]='\0';
   fgets(title,sizeof(title),fpcf);
   title[strlen(title)-1]='\0';
   /* start HTML */
   cgi_printf("<HTML>\n");
   cgi_printf("<HEAD>\n");
   cgi_printf("<TITLE>%s</TITLE>\n",title);
   cgi_printf("</HEAD>\n");
   cgi_printf("<BODY>\n");
   cgi_printf("<H1>%s</H1>\n",title);
#ifndef TABLES
   cgi_printf("<PRE>\n");
#else
   cgi_printf("<TABLE BORDER>\n");
#endif
   /* read headers */
#ifdef TABLES
   cgi_printf("<TR>\n");
#endif
   nfld=0;
   while(!feof(fpcf)) {
      if(fgets(fld,sizeof(fld),fpcf)!=NULL) {
         fld[strlen(fld)-1]='\0';
         nfld++;
#ifndef TABLES
         cgi_printf(" %-18s",fld);
#else
         cgi_printf("<TH>%-18s</TH>",fld);
#endif
      }
   }
   cgi_printf("\n");
   /* open database-file */
   if(!check_access(db)) {
      cgi_printf("<P>No access to file: %s</P>\n",db);
      goto fin2;
   }
   fpdb=fopen(db,"r");
   if(fpcf==NULL) {
       cgi_printf("<P>Can not open file: %s</P>\n",db);
       goto fin2;
   }
   /* read data */
   while(!feof(fpdb)) {
      if(fgets(lin,sizeof(lin),fpdb)!=NULL) {
         lin[strlen(lin)-1]='\0';
#ifdef TABLES
         cgi_printf("</TR>\n<TR>\n");
#endif
         p1=lin;
         for(i=0;i<nfld;i++) {
            p2=strstr(p1,";");
            if(p2==NULL) p2=lin+strlen(lin);
            strncpy(fld,p1,p2-p1);
            fld[p2-p1]='\0';
            p1=p2+1;
#ifndef TABLES
            cgi_printf(" %-18s",fld);
#else
            cgi_printf("<TD>%-18s</TD>",fld);
#endif
         }
         cgi_printf("\n");
      }
   }
fin2:
   fclose(fpdb);
#ifndef TABLES
   cgi_printf("</PRE>\n");
#else
   cgi_printf("</TR>\n</TABLE>\n");
#endif
   cgi_printf("<P>(control-file: %s\n)</P>\n",cf);
fin:
   cgi_printf("</BODY>\n");
   cgi_printf("</HTML>\n");
}
